package decatur.de.rigorous.numutil;

public class Power10 {
    public long m;
    public int e;
    
    public Power10 () {
	super ();
    }
    
    public void set (Power10 a) {
	m = a.m;
	e = a.e;
    }

    // set such that mantissa has length k
    public void set (double x, int k) {
	if (x==0.0) {
	    m=e=0; return;
	}
	boolean neg = (x<0.0);
	x = Math.abs(x);
	e = (int) Math.floor(Math.log(x)/Math.log(10.0))-k;
	m = (long) (x*Math.pow(10, -e));
	//    System.out.println("x: "+x+" e: "+e+" m: "+m);
	if (neg) m *= -1l;
    }
    
    public void neg () {
	m = -m;
    }
    
    private long pow10 (long l, int e) {
	for (int i=0; i<e; i++)
	    l *= 10;
	return l;
    }
	
    public void add (Power10 a) {
	long mant = a.m;
	if ( e<a.e )
	    mant = pow10 (mant, a.e-e);
	else if ( e>a.e ) {
	    m = pow10 (m, e-a.e);
	    e = a.e;
	}
	m += mant;
	reduce ();
    }
    
    public void reduce () {
	if (m==0) return;
	while (m%10==0l) {
	    m /= 10;
	    e++;
	}
    }


    public void nicestIn (double a, double b) {
	nicest (a, b);
    }
    
    public void nicestAt (double a, double eps) {
	eps = Math.abs(eps);
	nicest (a-eps, a+eps);
    }

    private double nicest (double a, double b) {
	if ( a<=0.0 && b>=0.0 ) return 0.0;
	int sign = 1;
	if ( b<=0.0 ) {
	    sign = -1;
	    double t=-a; a=-b; b=t;
	}
	//    System.out.println("nicest:");
	set((a+b)/2, 12);
	long last;
	double d = 0.0;
	do {
	    last = m;
	    m /= 10; e++;
	    d = doubleValue ();
	    if ( d<a || d>b ) break;
	    //      System.out.println("d: "+d+" a: "+a+" b: "+b+" sign: "+sign);
	} while (true);
	m = m+1;
	d = doubleValue ();
	if ( d>b ) {
	    m = last; e--;
	}
	m *= sign;
	return doubleValue ();
    }

    /*
      public static String format (double d) {
      Double10 x = new Double10();
      double eps = 1e-14;
      d *= (1.0+eps);
      x.set(d,12);
      return x.toString();
      }
      
      public static String niceNeighbor (double x, double dx) {
      dx = Math.abs (dx);
      return format (x-dx, x+dx);
      } 
      
      public static String format (double a, double b) {
      Double10 x = new Double10();
      x.nicest (a, b);
      return x.toString();
      }
    */

    public static String niceString (double x, double dx) {
	Power10 p = new Power10 ();
	p.nicestAt (x, dx);
	return p.toString ();
    }

    public String toString () {
	Double d = Double.valueOf(""+m+"e"+e);
	String s = d.toString();
	if ( s.endsWith(".0") )
	    return s.substring(0, s.length()-2);
	else return s;
    }
    
    public double doubleValue () {
	return m*Math.pow(10,e);
    }
    
    public float floatValue () {
	return (float) (m*Math.pow(10,e));
    }
}
