/*
 * Scale.java
 *
 * Created on January 11, 2004, 10:47 PM
 */

package decatur.de.rigorous.numutil;

/**
 *
 * @author  wolfgang
 */
public class Scale {
    
    private Magnitude[] mags;
    
    /** Creates a new instance of Scale */
    public Scale() {
    }
    
    public void normalize() {
        int carry=0;
        for (int i=0; i<mags.length; i++) {
            Magnitude m = mags[i];
            int v = carry+m.getValue();
            int r = m.getRange();
            if (v>= r) {
                m.setValue(v%r);
                carry = v/r;
            } else if (carry>0) {
                m.setValue(v);
            }
        }
    }
    
    public String toString() {
        String s = "";
        for (int i=mags.length-1; i>=0; i--) {
            s += " " + mags[i].toString();
        }
        return s;
    }
    
    public static void main(String[] argv) throws CloneNotSupportedException {
        Scale s1 = new Scale();
        s1.mags = new Magnitude[3];
        Scale s2 = new Scale();
        s2.mags = new Magnitude[3];
        
        Magnitude m;
        m = new Magnitude("sec");
        m.setRange(60);
        m.setValue(2000);
        s1.mags[0] = m;
        m = new Magnitude("min");
        m.setRange(60);
        m.setValue(0);
        s1.mags[1] = m;
        m = new Magnitude("h");
        m.setRange(24);
        m.setValue(0);
        s1.mags[2] = m;
        s1.normalize();
        
        m = new Magnitude("sec");
        m.setRange(60);
        m.setValue(8000);
        s2.mags[0] = m;
        m = new Magnitude("min");
        m.setRange(60);
        m.setValue(0);
        s2.mags[1] = m;
        m = new Magnitude("h");
        m.setRange(24);
        m.setValue(0);
        s2.mags[2] = m;
        s2.normalize();
        
        int i;
        for (i=s2.mags.length-1; i>=0; i--) {
            if (s1.mags[i]!=s2.mags[i])
                break;
        }
        // i==-1 for s1==s2?
        
        Scale s = (Scale) s1.clone();
        int v = s.mags[i].getValue();
        v -= v%5;
        while (v<s.mags[i].getRange()) {
            s.mags[i].setValue(v+5);
            System.out.println(s);
        }
    }
    
    
}
