package decatur.de.rigorous.numutil;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.StreamTokenizer;
import java.io.IOException;
import java.io.InputStream;

public class Scanner extends StreamTokenizer {

	public Scanner(InputStream input) {
		super(new BufferedReader(new InputStreamReader(input)));
		eolIsSignificant(true);
		commentChar('#');
		lowerCaseMode(true);
	}

	public void readEOL() throws IOException {
		if (ttype != StreamTokenizer.TT_EOL)
			signal("EOL expected");
		nextToken();
	}

	public void readEOLs() throws IOException {
		while (ttype == StreamTokenizer.TT_EOL)
			nextToken();
	}

	public void skipAfterEOL() throws IOException {
		while (ttype != StreamTokenizer.TT_EOL)
			nextToken();
		nextToken();
	}

	public int readInt() throws IOException {
		if (ttype != StreamTokenizer.TT_NUMBER)
			signal("Integer expected");
		short retval = (short) nval;
		nextToken();
		return retval;
	}

	public double readDouble() throws IOException {
		if (ttype != StreamTokenizer.TT_NUMBER)
			signal("Floating point number expected");
		double retval = (double) nval;
		nextToken();
		return retval;
	}

	public boolean isToken(String s) {
		return ttype == StreamTokenizer.TT_WORD && s.equals(sval);
	}

	public void signal(String message) throws IOException {
		throw new IOException("Scanner error: " + message + " at line "
				+ lineno());
	}
}
