package decatur.de.rigorous.parse;

import java.applet.Applet; 
import java.awt.*;

import decatur.de.rigorous.numutil.*;
import decatur.de.rigorous.plot2d.BoxedPanel;

public class GradientTool extends Applet {
  TextField func, x, y;
  TextArea diff0, diffx, diffy;
  Button eval;  
  TextArea message;

  public void init () {
    int n = 25;
    BoxedPanel p = new BoxedPanel();
    
    eval = new Button("Evaluate");
    func = new TextField ("x+2*y",n);
    x = new TextField ("[-2, -1]",n);
    y = new TextField ("[1, 2]",n);
    diff0 = new TextArea ("",3,n);//,TextArea.SCROLLBARS_NONE);
    diffx = new TextArea ("",3,n);//,TextArea.SCROLLBARS_NONE);
    diffy = new TextArea ("",3,n);//,TextArea.SCROLLBARS_NONE);
    message = new TextArea ("", 3, n);
    diff0.setEditable(false);
    diffx.setEditable(false);
    diffy.setEditable(false);

    p.add (1,1,0,0,new Label("f(x,y) :=", Label.RIGHT));
    p.add (3,1,1,0,func);

    p.add (1,1,0,1, new Label("x =", Label.RIGHT));
    p.add (3,1,1,1, x);

    p.add (1,1,0,2, new Label("y =", Label.RIGHT));
    p.add (3,1,1,2, y);

    p.add (4,3,4,0, message);

    p.add (1,1,0,3, new Label("f =", Label.RIGHT));
    p.add (3,1,1,3, diff0); 

    p.add (1,1,0,4, new Label("dfdx =", Label.RIGHT));
    p.add (3,1,1,4, diffx); 

    p.add (1,1,4,4, new Label("dfdy =", Label.RIGHT));
    p.add (3,1,5,4, diffy); 

    p.add (4,1,4,3, eval);

    add (p);
    
    evaluate ();
    validate ();
  }
  
  public boolean handleEvent(Event e) {
    if (e.id == Event.ACTION_EVENT) {
      if (e.target == eval) {
	evaluate();
	validate();
      }
    }
    return false;
  }
  
  void evaluate () {
    String s[] = {"x", "y"};
    Expression p;
    try {
      p = new Expression (func.getText(), s);
    }
    catch (Exception e) {
      message.setText ("Reading function:\n"+e.toString());
      return;
    }
    Interval[]  a = Interval.vector(2);
    
    try {
	a[0].parseString (x.getText());
    }
    catch (NumberFormatException e) {
	 message.setText("x-Range:\n"+e.toString());
	 return;
    }
    try {
	a[1].parseString (y.getText());
    }
    catch (NumberFormatException e) {
	 message.setText("y-Range:\n"+e.toString());
	 return;
    }

    try {
      p.eval(a);
    } catch ( ArithmeticException e ) {
      message.setText ("Evaluating:\n"+e.toString());
      return;
    }
    message.setText ("Evaluation successful!");

    diff0.setText("["+p.value().inf+",\n "+p.value().sup+"]");
    diffx.setText("["+p.partial(0).inf+",\n "+p.partial(0).sup+"]");
    diffy.setText("["+p.partial(1).inf+",\n "+p.partial(1).sup+"]");
  }
}


