package decatur.de.rigorous.plot;

import java.awt.*;

public class AwtDevice extends Device {
    private boolean filled;
    private boolean outlined;

    private Graphics g;
    FontMetrics fm = null;

    private Point p, q;
    
    public AwtDevice () {
	super ();
	p = new Point (0, 0);
	q = new Point (0, 0);
    }
    
    public void setContext (Graphics g) {
	this.g = g;
	fm = g.getFontMetrics ();
    }

    void setColor (int color) {
	g.setColor (new Color(color));
    }

    public void setDash (int pattern[]) {
    }

    void setFilled (boolean flag) {
	filled = flag;
    }
    
    void setOutlined (boolean flag) {
	outlined = flag;
    }

    public int stringWidth (String s) {
	return fm.stringWidth (s);
    }
    
    public int getAscent () {
	return fm.getAscent ();
    }
    
    public void drawString (String s, float x, float y, int align) {
	matrix.transform (p, x, y);
	int width;
	width = fm.stringWidth(s);
	int offset = 0;
	if ( align==CENTER )
	    offset = -width/2;
	else if ( align==LEFT )
	    offset = -width; 
	g.drawString (s, p.x+offset, p.y);
    }

    void drawLine (float x1, float y1, float x2, float y2) {
	matrix.transform (p, x1, y1);
	matrix.transform (q, x2, y2);
	g.drawLine (p.x, p.y, q.x, q.y);
    }

    public void drawPolyLine (float x[], float y[], int start, int length) {
	for (int i=start; i<start+length-1; i++)
		drawLine (x[i], y[i], x[i+1], y[i+1]);  
    }

    public void drawPolygon (float x[], float y[]) {
	Polygon poly = new Polygon ();
	for (int i=0; i<x.length; i++) {
	    matrix.transform (p, x[i], y[i]);	
	    poly.addPoint (p.x, p.y);
	}
	if ( filled )
	    g.fillPolygon (poly);
	
	if ( !filled || outlined )
	    g.drawPolygon (poly);
    }
    
    public void drawRect (float x, float y, float dx, float dy) {
	matrix.transform (p, x,y);
	matrix.dtransform (q, dx, dy);
	if (q.x<0) {
	    p.x += q.x;
	    q.x = -q.x;
	}
	if (q.y<0) {
	    p.y += q.y;
	    q.y = -q.y;
	}	
	
	if ( filled )
	    g.fillRect (p.x, p.y, q.x, q.y);
	else
	    g.drawRect (p.x, p.y, q.x, q.y);
    }

    public void clipRect (float x, float y, float dx, float dy) {
	matrix.transform (p, x,y);
	matrix.dtransform (q, dx, dy);
	if (q.x<0) {
	    p.x += q.x;
	    q.x = -q.x;
	}
	if (q.y<0) {
	    p.y += q.y;
	    q.y = -q.y;
	}	
	
	g.clipRect (p.x+2, p.y+2, q.x-4, q.y-4);
    }
}
