package decatur.de.rigorous.plot;


public class BoundingBoxDevice extends Device {
    private int debug = 0;
  
    public float xMin, xMax, yMin, yMax;
    private SbVec2f p, q;

    public BoundingBoxDevice () {
	super ();
	xMax = yMax = Float.NEGATIVE_INFINITY;
	xMin = yMin = Float.POSITIVE_INFINITY;

	p = new SbVec2f ();
	q = new SbVec2f ();
    }
    
    void setColor (int color) {}

    public void setDash (int pattern[]) {}

    void setFilled (boolean flag) {}
    
    void setOutlined (boolean flag) {}

    public int stringWidth (String s) {
	return 1;
    }
    
    public int getAscent () {
	return 1;
    }
    
    public void drawString (String s, float x, float y, int align) {
    }

    void drawLine (float x1, float y1, float x2, float y2) {
	matrix.transform (p, x1, y1);
	matrix.transform (q, x2, y2);
	xMin = Math.min (xMin, p.x);
	xMin = Math.min (xMin, q.x);
	yMin = Math.min (yMin, p.y);
	yMin = Math.min (yMin, q.y);
	xMax = Math.max (xMax, p.x);
	xMax = Math.max (xMax, q.x);
	yMax = Math.max (yMax, p.y);
	yMax = Math.max (yMax, q.y);
	if ( debug>0 ) dump ();
    }

    public void drawPolyLine (float x[], float y[], int start, int length) {
	for (int i=start; i<start+length-1; i++)
		drawLine (x[i], y[i], x[i+1], y[i+1]);  
    }

    public void drawPolygon (float x[], float y[]) {
	for (int i=0; i<x.length-1; i++)
	    drawLine (x[i], y[i], x[i+1], y[i+1]);
    }

    public void drawRect (float x, float y, float dx, float dy) {
	matrix.transform (p, x,y);
	matrix.dtransform (q, dx, dy);

	xMin = Math.min (xMin, p.x);
	xMin = Math.min (xMin, p.x+q.x);
	yMin = Math.min (yMin, p.y);
	yMin = Math.min (yMin, p.y+q.y);
	xMax = Math.max (xMax, p.x);
	xMax = Math.max (xMax, p.x+q.x);
	yMax = Math.max (yMax, p.y);
	yMax = Math.max (yMax, p.y+q.y);
	if ( debug>0 ) dump ();
    }
    
    public void clipRect (float x, float y, float dx, float dy) {}

    public void dump () {
	System.out.println ("Bounding Box:\n"+
			    xMin+" "+xMax+" "+yMin+" "+yMax);
    }
	
}












