package decatur.de.rigorous.plot;

import java.util.Stack;

public abstract class Device {
	public final static int CENTER = 0;
	public final static int LEFT = 1;
	public final static int RIGHT = 2;

	private Stack<SbMatrix> matrixStack;
	protected SbMatrix matrix;

	Device() {
		matrixStack = new Stack<SbMatrix>();
		matrix = new SbMatrix();
	}

	public void close() {
	}

	public void pushState() {
		matrixStack.push(matrix);
		matrix = new SbMatrix(matrix);
	}

	public void popState() {
		matrix = (SbMatrix) matrixStack.pop();
	}

	public float idx(int dx) {
		return dx / Math.abs(matrix.sx);
	}

	public float idy(int dy) {
		return dy / Math.abs(matrix.sy);
	}

	abstract void setColor(int color);

	abstract void setDash(int pattern[]);

	abstract void setFilled(boolean flag);

	abstract void setOutlined(boolean flag);

	public abstract void drawString(String s, float x, float y, int align);

	abstract void drawLine(float x1, float y1, float x2, float y2);

	public abstract void drawPolyLine(float x[], float y[], int start, int stop);

	public abstract void drawRect(float x, float y, float width, float height);

	public abstract void clipRect(float x, float y, float width, float height);

	public abstract void drawPolygon(float x[], float y[]);

	public abstract int stringWidth(String s);

	public abstract int getAscent();
}
