package decatur.de.rigorous.plot;

public class SoLineSet extends SoShape {
    public float x[];
    public float y[];
    public int numVertices [];
    
    public SoLineSet () {
	super ();
    }

    public SoLineSet (int nVertices, int nPolyLines) {
	super ();
	resize (nVertices, nPolyLines);
    }

    public SoLineSet (int nVertices) {
	super ();
	resize (nVertices, 1);
	numVertices[0] = nVertices;
    }
    
    public Object clone () { 
	SoLineSet lineset = (SoLineSet) super.clone();
	
	if ( pattern!=null )
	    lineset.pattern = (int[]) pattern.clone();
	lineset.x = (float[]) x.clone();
	lineset.y = (float[]) y.clone();
	lineset.numVertices = (int[]) numVertices.clone();
	//	super.copy (lineset);
	return lineset;
    }

    public void resize (int nVertices, int nPolyLines) {
	x = new float[nVertices];
	y = new float[nVertices];
	numVertices = new int[nPolyLines];
    }
    
    public void set (double x[], double y[]) {
	for (int i=0; i<x.length; i++) {
	    this.x[i] = (float) x[i];
	    this.y[i] = (float) y[i];
	}
	numVertices[0] = x.length;
    }

    public void paint (Device dev) {
	for (int i=0, start=0; i<numVertices.length; i++) {
	    dev.drawPolyLine (x, y, start, numVertices[i]);
	    start += numVertices[i];
	}
    }
}
