package decatur.de.rigorous.plot;

import java.awt.Color;

public abstract class SoShape extends SoNode {
    int color;
    public int []pattern = null;
    
    SoShape () {
	color = Color.black.getRGB();
    }

    public void setColor (int color) {
	this.color = color;
    }

    public void setColor (Color color) {
	this.color = color.getRGB () & 0xFFFFFF;
    }

    public void setDash (int pattern[]) {
	this.pattern = new int[pattern.length];
	System.arraycopy (pattern, 0, this.pattern, 0, pattern.length);
    }

    public void render (Device dev) {
	dev.setColor (color);
	dev.setDash  (pattern);
	paint (dev);
    }
    
    abstract public void paint (Device dev);
}
