package decatur.de.rigorous.plot2d;
import java.awt.*;

public class BoxedPanel extends Panel {
  private GridBagConstraints c;
  private GridBagLayout l;
  
  public BoxedPanel () {
    c = new  GridBagConstraints();
    c.insets = new Insets(3,3,3,3);
    l = new GridBagLayout();
    setLayout (l);
  }

  public void setFill (int fill) {
    c.fill = fill;
  }

  public void add (int width, int height,
		   int gridx, int gridy, Component comp) {
    c.gridx = gridx; c.gridy = gridy;
    c.gridwidth = width; c.gridheight = height;
    //  c.weightx = width/10.0; c.weighty = height/8.0;
    c.weightx = 1.0; c.weighty = 1.0;
    if ( comp instanceof TextField )
      c.fill = GridBagConstraints.NONE;
    else
      c.fill = GridBagConstraints.BOTH;
    l.setConstraints (comp, c);
    add(comp);
  }

  public Insets insets() {
    return new Insets(4,4,5,5);
  }

  public void paint(Graphics g) {
    Dimension d = getSize();
    Color bg = getBackground();
    
    g.setColor(bg);
    g.draw3DRect(0, 0, d.width - 1, d.height - 1, true);
    g.draw3DRect(3, 3, d.width - 7, d.height - 7, false);
  }
}
